/*  $Id: opt.s,v 1.1 1996/12/13 14:13:29 shaggy Exp shaggy $
 *      machine specific optimizations
 *      for I386
 *      relative path: ./I386
 *  
 *       Intel 386 PC  machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* $Log: opt.s,v $
 *  Revision 1.1  1996/12/13  14:13:29  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */

#include <opt.h>


#ifdef __ELF__
#	define GLOBL_C(n)	n: .globl n
#else
#	define GLOBL_C(n)	_##n: .globl _##n
#endif


#ifdef MEMCPY
#ifdef I386DX	/* attempt to move longwords */
/* void memcpy(char *dest, char *src, int size) */
GLOBL_C(memcpy)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
	movl	16(%ebp),%ecx	
	cmpl	$0,%ecx		/* leave if done */
	je	3f
1:	test	$3,%edi		/* align dest to longword boundary */
	jz	2f
	movsb	1	/* copy a byte */
	loop	1b
	jmp	3f
2:	cmpl	$0,%ecx		/* leave if done */
	je	3f		 
	movl	%ecx,%edx
	shrl	$2,%ecx		/* number of longwords */
	andl	$3,%edx		/* number of bytes remainder */
	rep
	movsl			/* copy longwords */
	cmpl	$0,%edx		/* leave if done */
	je	3f
	movl	%edx,%ecx	/* get remainder */
	rep
	movsb			/* copy bytes */
3:	popl	%edi
	popl	%esi	
	leave
	ret	
#endif

#ifdef I386SX	/* 16-bit bus -- attempt to move words only */
/* void memcpy(char *dest, char *src, int size) */
GLOBL_C(memcpy)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
	movl	16(%ebp),%ecx	
	cmpl	$0,%ecx		/* leave if done */
	je	3f
1:	test	$1,%edi		/* align dest to word boundary */
	jz	2f
	movsb			/* copy a byte */
	dec	%ecx
2:	cmpl	$0,%ecx		/* leave if done */
	je	3f		 
	movl	%ecx,%edx
	shrl	$1,%ecx		/* number of longwords */
	rep
	movsw			/* copy words */
	test	$1,%edx		/* check remainder */
	jz	3f
	movsb			/* copy leftover byte */
3:	popl	%edi
	popl	%esi	
	leave
	ret	
#endif
#endif



#ifdef MEMSET
/* void memset(char *dest, uchar data, int nbytes) */
GLOBL_C(memset)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	movl	8(%ebp),%edi
	movl	16(%ebp),%ecx
	movl	12(%ebp),%eax
	cmpl	$0,%ecx
	je	1f
	rep	
	stosb
1:	popl	%edi
	leave
	ret
#endif

#ifdef MEMSET_W
/* void memset_w(char *dest, ushort data, int nwords) */
GLOBL_C(memset_w)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	movl	8(%ebp),%edi
	movl	16(%ebp),%ecx
	movl	12(%ebp),%eax
	cmpl	$0,%ecx
	je	1f
	rep	
	stosw
1:	popl	%edi
	leave
	ret
#endif

#ifdef MEMSET_L
/* void memset_l(char *dest, int nwords, ulong data) */
GLOBL_C(memset_l)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	movl	8(%ebp),%edi
	movl	16(%ebp),%ecx
	movl	12(%ebp),%eax
	cmpl	$0,%ecx
	je	1f
	rep	
	stosl
1:	popl	%edi
	leave
	ret
#endif


#ifdef STRCPY
GLOBL_C(strcpy)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	pushl	%esi
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
1:	lodsb
	stosb
	cmpb	$0,%al
	jnz	1b
	mov	12(%ebp),%eax
	popl	%esi
	popl	%edi
	leave
	ret
#endif

#ifdef STRCAT
GLOBL_C(strcat)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	pushl	%esi
	movl	8(%ebp),%esi
1:	lodsb
	cmpb	$0,%al
	jnz	1b
	leal	-1(%esi),%edi
	movl	12(%ebp),%esi
1:	lodsb
	stosb
	cmpb	$0,%al
	jnz	1b
	mov	8(%ebp),%eax
	popl	%esi
	popl	%edi
	leave
	ret
#endif

#ifdef STRLEN
GLOBL_C(strlen)
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	movl	8(%ebp),%esi
1:	lodsb
	cmpb	$0,%al
	jnz	1b
	movl	%esi,%eax
	subl	8(%ebp),%eax
	decl	%eax
	popl	%esi
	leave
	ret
#endif

