/*  $Id: srt0.s,v 1.1 1996/11/07 11:56:55 shaggy Exp $
 *      startup runtime module for kernel
 *      
 *      relative path: ./I386
 *  
 *       Intel 386 PC  machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: srt0.s,v $
 *  Revision 1.1  1996/11/07  11:56:55  shaggy
 *  Initial revision
 *
 *
 *  Created in 1992
 */


#include <sys/param.h>
#include <bootparam.h>
#include <mdresource.h>


/* NOTE: (this applies to all assembly code)
   C functions on the 386 will automatically save all registers
   used except eax, ecx, and edx
*/

/****************************************************************/
/*	Important note:						*/
/*	This file is no longer used, now that SOLO is being	*/
/*	used for booting.  Instead, the kernel is linked with	*/
/*	the srt0.o file in the lib/boot directory of SOLO.	*/
/****************************************************************/

.globl	_start
.globl 	_end
.globl  _bootparam

.comm	_kstack_data,KSTACK_SIZE

.text
_start:
_bootparam:
/* NOTE: when this is first executed, it is located at linear address 0
 * and must be remapped to KERNBASE before Main() is called
 * Therefore all addressing until the remapping must be pc-relative
 * and thus relocatable
 * see the note at the bottom of this file for more info
 */
	jmp	_skip_param  
/* forever:jmp	forever */
	.org	P_TSIZE
_skip_param:
	cld
	cli
	/* initialize segments */
	movl	$0x10,%eax
	mov	%ax,%ds
	mov	%ax,%es
	movw	$0x6363,0xb8002
	lgdt	_gdt_init-KERNBASE
	lss	_kstack_temp-KERNBASE,%esp
	movl	$ SEG_INIT_DATA,%eax
	mov	%ax,%ds
	mov	%ax,%es
	xorl	%eax,%eax
	mov	%ax,%fs
	mov	%ax,%gs
	ljmp	$ SEG_INIT_CODE,$ajmp	/* reload CS:IP */
ajmp:
	call	_vm_init	/* initialize virtual memory */
	lgdt	_gdt_base
	lidt	_idt_base
	/* reinitialize segments with new GDT values */
	movl	%cr0,%eax
	orl	$0x80000000,%eax	/* turn on vm paging */
	movl	%eax,%cr0
	ljmp	$ SEG_KERN_CODE,$loadcs		/* reload CS:IP */
loadcs:
	movl	$ SEG_KERN_DATA,%eax
	mov	%ax,%ds
	mov	%ax,%es
	lss	_kstack_frame,%esp 
	pushl	$0		/* no return address */
	jmp	_Main

.align 4
_gdt_init:
	.word GDT_SIZE*8-1
	.long _gdt-KERNBASE

.align 4
_gdt_base:
	.word GDT_SIZE*8-1
	.long _gdt  

.align 4
_idt_base:
	.word IDT_SIZE*8-1
	.long _idt  

.data

.align 4
_kstack_temp:	.long	_kstack_data+KSTACK_SIZE
		.word	SEG_INIT_DATA
.align 4
_kstack_frame:	.long	_kstack_data+KSTACK_SIZE
		.word	SEG_KERN_DATA

