/*  $Id: stubs.s,v 1.1 1996/12/11 00:38:58 shaggy Exp shaggy $
 *      stubs for VAX kernels
 *      relative path: ./I386
 *  
 *       Intel 386 PC  machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: stubs.s,v $
 *  Revision 1.1  1996/12/11  00:38:58  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */


#include <sys/param.h>
#include <event.h>
#include <mdresource.h>
#include <port.h>
#include <boot/bootparam.h>


#ifdef __ELF__
#	define C(n)	n
#	define GLOBL_C(n)	n: .globl n
#else
#	define C(n)	_##n
#	define GLOBL_C(n)	_##n: .globl _##n
#endif



#define LCALL(seg,ofs)	.byte 0x9a; .long ofs; .word seg


#define SAVE_USP	\
	cmpl	$ SEG_KERN_DATA, 8(%esp);\
	jne	9f;			 \
	movl	C(thread_context),%edx;	 \
	movl	12(%esp),%eax;		 \
	movl	%eax,CONTEXT_USP(%edx);	 \
9:


.align 4
GLOBL_C(isr_table)
/* Intel 386 reserved interrupts/exceptions */
	.long	_isr_divide_err
	.long	_isr_debug
	.long	_isr_nmi	
	.long	_isr_bkpt
	.long	_isr_into
	.long	_isr_bound
	.long	_isr_inv_op
	.long	_isr_no_coproc
	.long	_isr_double_fault
	.long	_isr_coproc_seg_fault
	.long	_isr_invalid_task
	.long	_isr_no_segment
	.long	_isr_stack_fault
	.long	_isr_general_protection
	.long	_isr_page_fault
	.long	_isr_invalid
	.long	_isr_coproc_error
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
	.long	_isr_invalid
/* PIC1 interrupts: */
	.long	_isr_irq0	/* clock */
	.long	_isr_irq1	/* keyboard */
	.long	_isr_irq2	/* video */
	.long	_isr_irq3	/* serial 1,3 */
	.long	_isr_irq4	/* serial 0,2 */
	.long	_isr_irq5	/* fixed disk */
	.long	_isr_irq6	/* floppy disk */
	.long	_isr_irq7	/* parallel printer */
/* PIC2 interrupts: */
	.long	_isr_irq8	/* real-time clock */
	.long	_isr_irq9	/* redirect cascade */
	.long	_isr_irq10	/* reserved */
	.long	_isr_irq11	/* reserved */
	.long	_isr_irq12	/* mouse */
	.long	_isr_irq13	/* coprocessor exception */
	.long	_isr_irq14	/* fixed disk */
	.long	_isr_irq15	/* reserved */

/*** ISR stub routines: ***/ 
_isr_invalid:
	pushl	$0
	pushl	$ TRAP_INVALID
	jmp	systrap
_isr_debug:	
	pushl	$0
	pushl	$ TRAP_TRACE
	jmp	systrap
_isr_nmi:
	pushl	$0
	pushl	$ TRAP_FAULT
	jmp	systrap
_isr_bkpt:
	pushl	$0
	pushl	$ TRAP_BKPT
	jmp	systrap
_isr_inv_op:
	pushl	$0
	pushl	$ TRAP_RESVOP
	jmp	systrap
_isr_no_coproc:
	pushl	$0
	pushl	$ TRAP_FAULT
	jmp	systrap
_isr_double_fault: /* error code 0 */
	pushl	$ TRAP_DOUBLE
	jmp	systrap	
_isr_coproc_seg_fault:
	pushl	$0
	pushl	$ TRAP_FAULT
	jmp	systrap
_isr_invalid_task: /* has error code */
	pushl	$ TRAP_INVTASK
	jmp	systrap
_isr_no_segment: /* has error code */
	pushl	$ TRAP_FAULT
	jmp	systrap
_isr_stack_fault: /* has error code */
	pushl	$ TRAP_FAULT
	jmp	systrap
_isr_general_protection: /* has error code */
	cmpl	$user_return,4(%esp)
	je 	user_return_trap
	pushl	$ TRAP_ACCV
	jmp	systrap
_isr_page_fault: /* has error code */
	pushl	$ TRAP_PGFAULT
	/* falls through to systrap... */
systrap:
	cli
	cld
	pushl %eax
	pushl %ecx
	pushl %edx
	pushl %ds
	pushl %es
	movl $ SEG_KERN_DATA,%eax
	mov %ax,%ds
	mov %ax,%es
	movl %cr2,%eax
	pushl %eax		/* va */
	pushl 44(%esp)		/* pc */
	pushl 32(%esp)		/* errorcode */
	pushl 32(%esp)		/* trap code */
	movl %ebp,40(%esp)	/* save ebp */
	lea 40(%esp),%ebp	/* point ebp to it */
	call C(trap_svc)
	addl $16,%esp
	popl %es
	popl %ds
	popl %edx
	popl %ecx
	popl %eax
	leave
	iret

_isr_coproc_error:
	pushl	$0
	pushl	$ TRAP_FAULT
	jmp	systrap

_isr_divide_err:
	pushl	$ ARITH_INTDIV0
	pushl	$ TRAP_ARITH
	jmp	systrap
_isr_into:
	pushl	$ ARITH_INTOVF
	pushl	$ TRAP_ARITH
	jmp	systrap
_isr_bound:
	pushl	$ ARITH_RANGE
	pushl	$ TRAP_ARITH
	jmp	systrap
	


_isr_irq1:	pushl $1;	jmp call_int_svc
_isr_irq2:	pushl $2;	jmp call_int_svc
_isr_irq3:	pushl $3;	jmp call_int_svc
_isr_irq4:	pushl $4;	jmp call_int_svc
_isr_irq5:	pushl $5;	jmp call_int_svc
_isr_irq6:	pushl $6;	jmp call_int_svc
_isr_irq7:	pushl $7;	jmp call_int_svc
_isr_irq8:	pushl $8;	jmp call_int_svc
_isr_irq9:	pushl $9;	jmp call_int_svc
_isr_irq10:	pushl $10;	jmp call_int_svc
_isr_irq11:	pushl $11;	jmp call_int_svc
_isr_irq12:	pushl $12;	jmp call_int_svc
_isr_irq13:	pushl $13;	jmp call_int_svc
_isr_irq14:	pushl $14;	jmp call_int_svc
_isr_irq15:	pushl $15;	jmp call_int_svc
_isr_irq0:	pushl $0	/* fall through... */

/* generic interrupt service call */
call_int_svc:
	cli
	cld
	incb	C(int_level)
	pushl	%eax
	pushl	%ecx
	pushl	%edx
	pushl	%ds
	pushl	%es
	movl	$ SEG_KERN_DATA,%eax
	mov	%ax,%ds
	mov	%ax,%es
	movl	20(%esp),%ecx	/* get IRQ num */
	movl	%ecx,%edx		
	shll	$1,%edx
	movw	C(irq_mask)(%edx),%dx
	inb	$ PIC1_OCW1,%al		
	jmp	1f		/* delay */
1:	jmp	1f
1:	xchgb	%dl,%al 
	orb	%dl,%al
	outb	%al,$ PIC1_OCW1	/* mask out current int (0-7) */
	inb	$ PIC2_OCW1,%al	
	jmp	1f		/* delay */
1:	jmp	1f	
1:	xchgb	%dh,%al
	orb	%dh,%al
	outb	%al,$ PIC2_OCW1	/* mask out current int (8-15) */
	movb	%cl,%al
	andb	$7,%al	
	orb	$0x20,%al
	testb	$8,%cl
	jz	1f
	outb	%al,$ PIC2_OCW2	/* acknowledge IRQ on bank 2 */
	jmp	1f
1:	outb	%al,$ PIC1_OCW2	/* acknowledge IRQ on bank 1 */
	sti			/* enable other ints */
	pushl	%edx		/* push old IRQ enable */
	pushl	%ecx		/* push IRQ number */
	call	C(heartbeat)	/* update heartbeat */
	movl	(%esp),%ecx	/* get IRQ num in ecx again */
	shll	$2,%ecx		/* convert to index */
	pushl	C(irq_param)(%ecx)	/* push parameter */
	call	C(irq_call)(%ecx)	/* call IRQ service routine */
	addl	$8,%esp
	popl	%edx		/* get saved IRQ enable */
	popl	%es
	popl	%ds
	cli
	movb	%dl,%al
	outb	%al,$ PIC1_OCW1	/* re-enable current int (bank 1) */
	jmp	1f
1:	jmp	1f
1:	movb	%dh,%al
	outb	%al,$ PIC2_OCW1	/* re-enable current int (bank 2) */
 	popl	%edx
	popl	%ecx
	popl	%eax
	addl	$4,%esp
	decb	C(int_level)
	jz	2f
	iret
2:	cmpb	$0,C(cswitch_force)
	jne	3f
	iret
3:	
	movb	$0,C(cswitch_force)
	ljmp	$ SEG_THREAD, $0
	iret

/* void clock_set_interval(hertz) */
GLOBL_C(clock_set_interval)
	pushl	%ebp
	movl	%esp,%ebp
	pushfl	
	cli
	call	C(solo_MapBootParam)	/* returns eax = saved map */
	pushl	%ebx			/* save ebx */
	movl	C(bootparam),%ebx	/* ebx -> BootParam */
	pushl	%eax			/* push as param1 for unmap */

	movl	8(%ebp),%ecx		/* ecx = hertz */
	movl	%ecx,%eax		/* eax = hertz */
	shrl	$2,%eax			/* eax = hertz/2 */
	addl	$ TIMER_HERTZ,%eax	/* eax = timer_hertz+hertz/2 */
	movl	%eax,%edx		/* edx = timer_hertz+hertz/2 */
	shrl	$16,%edx		/* dx = high(timer_hertz+round) */
	andl	$0xffff,%eax		/* clear high part of eax */
	divw	%cx,%ax		/* divide dx:ax by cx */
	movw	%ax,BootParam_timer0_count(%ebx)
	
	pushl	%eax			/* save result */
	movb	$0x34,%al		/* counter 0, lo/hi/binary */
	outb	%al,$ PIT_MODE	/* program counter 0 */
	movb	%al,BootParam_timer0_mode(%ebx)
	popl	%eax
	outb	%al,$ PIT_CHAN0	/* send low byte */
	movb	%ah,%al
	outb	%al,$ PIT_CHAN0	/* send high byte */

	call	C(solo_UnmapBootParam)
	popl	%eax
	popl	%ebx			/* restore ebx */

	popfl
	leave
	ret


GLOBL_C(interrupt_enable)
	movb	$0,%al
	outb	%al, $ PIC1_OCW1	/* enable IRQ 0-7 */
	outb	%al, $ PIC2_OCW1	/* enable IRQ 8-15 */
	sti				/* enable interrupts */
	ret

GLOBL_C(ObjCall)
	pushl	%ebp
	movl	%esp,%ebp
	movl	4(%ebp),%ecx
	movl	8(%ebp),%edx
	movl	$0,%eax
	LCALL	(SEG_OBJCALL,0)
	leave
	ret

GLOBL_C(ObjCall_Trap)
	pushl	%ebp
	movl	%esp,%ebp
	movl	4(%ebp),%ecx
	movl	8(%ebp),%edx
	movl	$0xffffffff,%eax
	LCALL	(SEG_OBJCALL,0)
	leave
	ret

GLOBL_C(ObjCall_Self)
	pushl	%ebp
	movl	%esp,%ebp
	movl	4(%ebp),%ecx
	movl	28(%ebp),%edx
	movl	$0,%eax
	LCALL	(SEG_OBJCALL,0)
	leave
	ret

GLOBL_C(ObjCall_gate)
	SAVE_USP
	push	%ds
	push	%es
	pushl	%ecx
	pushl	%edx
	pushl	%eax
	movl	$ SEG_KERN_DATA,%eax
	mov	%ax,%ds
	mov	%ax,%es
	lea	8(%ebp),%eax
	pushl	%eax	
	call	C(ObjCall_svc)
	addl	$16,%esp
	pop	%es
	pop	%ds
	lret	

GLOBL_C(Label)
	pushl	%ebp
	movl	%esp,%ebp
	LCALL	(SEG_LABEL,0)
	leave
	ret

GLOBL_C(Label_gate)
	SAVE_USP
	pushl	8(%ebp)
	call	C(Label_svc)
	addl	$4,%esp
	lret	

GLOBL_C(ObjString)
	pushl	%ebp
	movl	%esp,%ebp
	LCALL	(SEG_OBJSTRING,0)
	leave
	ret

GLOBL_C(ObjString_gate)
	SAVE_USP
	pushl	16(%ebp)
	pushl	12(%ebp)
	pushl	8(%ebp)
	call	C(ObjString_svc)
	addl	$12,%esp
	lret	


GLOBL_C(is_kernel)
	mov	%cs,%ax
	cmpw	$ SEG_KERN_CODE, %ax
	movl	$0,%eax
	jne	1f
	incl	%eax
1:	ret

GLOBL_C(call_user)
	pushl	%ebp
	movl	%esp,%ebp
	movl	C(thread_context),%eax
	movl	%ebp,CONTEXT_SP0(%eax)
	movl	CONTEXT_USP(%eax),%edx
	movl	$ SEG_USER_DATA+RPL_USER,%eax
	subl	$4,%edx
	movl	$user_return,(%edx)	/* return address */
	pushl	%eax
	pushl	%edx
	pushl	$ SEG_USER_CODE+RPL_USER
	pushl	8(%ebp)
	mov	%ax,%ds
	mov	%ax,%es
	lret
user_return:	
	int	$0x0d		/* cause protection violation */
user_return_trap:
	movl	C(thread_context),%edx
	movl	16(%esp),%ecx
	movl	%ecx,CONTEXT_USP(%edx)
	addl	$24,%esp
	popl	%ebp
	ret

/* yes, we still need this for ELF, because our dynamic linker, when
 * loading a.out modules, expects to be able to find this
 */
#ifdef __ELF__
GLOBL_C(__main)
	ret
#endif


.align 4
dt_ptr:
dt_size:
	.word	0
dt_adr:
	.long 	0


GLOBL_C(load_gdt)
	call	set_dt_ptr
	lgdt	dt_ptr
	ljmp	$ SEG_KERN_CODE, $loadcs
loadcs:	
	movw	$ SEG_KERN_DATA, %ax
	mov	%ax, %ds
	mov	%ax, %es
	mov	%ax, %ss
	ret


GLOBL_C(load_idt)
	call	set_dt_ptr
	lidt	dt_ptr
	ret


set_dt_ptr:
	movl	8(%esp),%eax	// eax = address
	movl	%eax,dt_adr	
	movl	12(%esp),%eax
	decl	%eax		// eax = size-1
	movw	%ax,dt_size
	ret

