/*  mdthread.c                                                  (CRC:b46d09ae)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:11 1996
 *      header update: Wed Dec 18 07:16:32 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* mdthread.c
 *  machine dependent thread control
 *  for I386 architectures
 *  to be included by sys/thread.c
 */


#include <privreg.h>


extern label_t _data;



static __inline__ void context_switch(void)
{
	cswitch_enable = TRUE;
	mtpr(3,R_SIRR);
}

static __inline__ void context_set(Context *context)
{
	mtpr(context->pcbb, R_PCBB);
}

static void force_exit(void)
{
obj_t rv;
	__asm__("movl %%r0,%0":"g="(rv));	/* get return value */
	err_(OBJ_THREAD,_free,rv,___,___);
	while(1)
		continue;
}

static __inline__ void mdthread_spawn(Thread *new, vaddr func, ulong param)
{
ulong *sp;
vaddr tmp;
extern void force_exit(void);
	new->context.pc = func+2;
	sp = (ulong*)new->kstack;
	tmp = vm_temp_share(&new->stack, (vaddr)sp - PAGE_SIZE, 
				PAGE_SIZE, VM_KRW);
	new->context.ap = (vaddr)sp - 12;
	new->context.fp = (vaddr)sp - 32;
	new->context.ksp = (vaddr)sp - 32;
	new->context.usp = new->ustack;
	sp = (ulong*)(tmp+PAGE_SIZE);
	*(--sp) = 0;	
	*(--sp) = param;
	*(--sp) = 1;			/* parameter count */
	*(--sp) = (vaddr)force_exit+2;	/* return address */
	*(--sp) = 0; 			/* old fp */
	--sp; *sp = (vaddr)sp+20; 	/* old ap */
	*(--sp) = 0x20000000;		/* regmask=0 psw=0 */
	*(--sp) = 0x00000000;		/* condition handler */
	vm_temp_free(tmp);
	new->context.pcbb = vm_getphys((vaddr)&new->context);
}


static __inline__ void mdthread_destroy(Thread *node)
{
}



/* set up the initial thread's context */
static __inline__ void mdthread_init(void)
{
int n;
	thread_context->p0br = 0;
	thread_context->p0lr = 0;
	thread_context->p1br = 0;
	thread_context->p1lr = 0;
	mfpr(R_ASTL, n);
	thread_context->astlvl = n & 7;
	thread_context->pme = 0;
	thread_context->pcbb = vm_getphys((vaddr)thread_context);
	thread_context->usp = thread->ustack;
}

