/*  privreg.h                                                   (CRC:da41359a)
 *      relative path: ./VAX
 *      creation date: 1992
 *      last modified: Wed May 22 21:28:14 1996
 *      header update: Wed Dec 18 07:16:38 1996
 *  
 *       Digital VAX machine dependent code
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* privreg.h
 * privileged registers for the VAX
 */


#define R_KSP	0x00
#define R_ESP	0x01
#define R_SSP	0x02
#define R_USP	0x03
#define R_ISP	0x04
#define R_P0BR	0x08
#define R_P0LR	0x09
#define R_P1BR	0x0a
#define R_P1LR	0x0b
#define R_SBR	0x0c
#define R_SLR	0x0d
#define R_PCBB	0x10
#define R_SCBB	0x11
#define R_IPL	0x12
#define R_ASTL	0x13
#define R_SIRR	0x14
#define R_SISR	0x15
#define R_TODR	0x1b
#define R_MME	0x38
#define R_TBIA	0x39
#define R_TBIS	0x3a
#define R_SID	0x3e

#if defined(KIMS) || defined(MVAX)
#define R_ICCS	0x18		/* only bit 6 (enable) is used */
#define privreg_canread(x)	((x<5)||(x>7&&x<14)||(x>15&&x<20)\
				||(x>0x28&&x<0x2c)||(x==0x38)\
				||(x==0x3e))
#endif

#if defined(VAX780) || defined(VAX750)
#define R_ASTR	0x13
#define R_ICCS	0x18
#define R_NICR	0x19
#define R_ICR	0x1a
#define R_RXCS	0x20
#define R_RXDB	0x21
#define R_TXCS	0x22
#define R_TXDB	0x23
#define R_TB	0x3b
#define R_PMR	0x3d
#endif


