/*  global.h                                                    (CRC:b2355628)
 *      relative path: ./include/sys
 *      creation date: 1992
 *      last modified: Wed May 22 21:41:07 1996
 *      header update: Wed Dec 18 07:17:41 1996
 *  
 *       Include files
 *        System Include files
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#ifndef KERNEL
#error	Cannot include global.h from non-kernel programs
#endif

#include <sys/types.h>
#include <sys/resource.h>
#include <event.h>
#include <object.h>
#include <mdglobal.h>

#ifndef GLOBAL
#define GLOBAL extern
#endif

/* kernel info: */
GLOBAL KernInfo kinfo;

/* kernel task: */
GLOBAL Task kernel;

/* common object classes: */
GLOBAL obj_t class_class;
GLOBAL obj_t class_object;
GLOBAL obj_t class_buffer;
GLOBAL obj_t class_thread;
GLOBAL obj_t class_task;
GLOBAL obj_t class_dir;
GLOBAL obj_t class_staticfile;

/* event allocator: */
GLOBAL ZoneP event_zone;

/* context switching: */
GLOBAL Queue runq, waitq, deadq;
extern Thread *thread;
extern Thread *null_thread;	/* when load = 0.0 */		
GLOBAL Thread *cleanup_thread;	/* when load = 0.0 */		
GLOBAL Context *thread_context;
GLOBAL boolean cswitch_enable;

/* interrupts: */
GLOBAL uchar int_level;		/* number of nested interrupts */

/* events: */
GLOBAL Event panic_event;
GLOBAL Queue eventq;
GLOBAL lock_t eventlock;

/* compilation defined: */
extern char *machparam;		/* compilation parameters */
extern char *mkdate;		/* date of most recent 'make' */
extern char *mkuser;		/* user who did the 'make' */
extern char *mkhost;		/* host on which it was created */

#endif /* __GLOBAL_H__ */

