/*  unistd.h                                                    (CRC:31a44fb6)
 *      relative path: ./include
 *      creation date: 1992
 *      last modified: Wed May 22 21:36:15 1996
 *      header update: Wed Dec 18 07:17:53 1996
 *  
 *       Include files
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __UNISTD_H__
#define __UNISTD_H__

#include <sys/types.h>
#include <stddef.h>

#define R_OK	4
#define W_OK	2
#define X_OK	1
#define F_OK	0
#define STDIN_FILENO	0
#define STDOUT_FILENO	1
#define STDERR_FILENO	2
#define _PC_CHOWN_RESTRICTED	XXX
#define _PC_MAX_CANNON		XXX
#define _PC_MAX_INPUT		XXX
#define _PC_NAME_MAX		XXX
#define _PC_NO_TRUNC		XXX
#define _PC_PATH_MAX		XXX
#define _PC_PIPE_BUF		XXX
#define _PC_VDISABLE		XXX
#define _POSIX_CHOWN_RESTRICTED	
#define _POSIX_JOB_CONTROL	
#define _POSIX_NO_TRUNC
#define _POSIX_SAVED_IDS
#define _POSIX_VDISABLE
#define _POSIX_VERSION
#define _SC_ARG_MAX		XXX
#define _SC_CHILD_MAX		XXX
#define _SC_CLK_TCK		XXX
#define _SC_JOB_CONTROL		XXX
#define _SC_NGROUPS_MAX		XXX
#define _SC_OPEN_MAX		XXX
#define _SC_SAVED_IDS		XXX
#define _SC_STREAM_MAX		XXX
#define _SC_TZNAME_MAX		XXX
#define _SC_VERSION		XXX	


extern ulong sleep(ulong sec);
extern void _exit(status_t status);
extern int read(int fildes, void *buf, ulong nbytes);
extern int write(int fildes, const void *buf, ulong nbytes);

#endif /* __UNISTD_H__ */

