/*  unistd.c                                                    (CRC:79248d45)
 *      relative path: ./posix
 *      creation date: 1992
 *      last modified: Wed May 22 21:37:07 1996
 *      header update: Wed Dec 18 07:18:02 1996
 *  
 *       POSIX standard library
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* unistd.c
 *  Posix compliant standard functions 
 */

#include <sys/types.h>
#include <sys/resource.h>
#include <object.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <time.h>

extern label_t _msleep;

ulong sleep(ulong seconds)
{
	_(OBJ_THREAD, _msleep, seconds*1000, ___, ___);
	return(0);
}


void _exit(status_t status)
{
	_(OBJ_THREAD, _free, status, ___, ___);
}


char *sys_errlist[1] = {"ok"};
int sys_nerr = 1;

int fstat(int fd, struct stat *buf) 
{
	printf("fstat\n");
	return(0);
}

struct tm *localtime(const time_t *timer)
{
	printf("localtime\n");
	return(NULL);
}

time_t time(time_t *timer)
{
	printf("time\n");
	return(0);
}

