/*  initlabels.c                                                (CRC: c292f4a)
 *      relative path: ./sys
 *      creation date: 1992
 *      last modified: Wed Dec 18 07:18:09 1996
 *      header update: Wed Dec 18 07:18:10 1996
 *  
 *       Microkernel system files
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* sys/initlabels.c
 * initializes labels
 * - this code was written by 'makelabels'
 */
#include <sys/types.h>
#include <object.h>
#include <sys/label.h>
#include <stddef.h>


label_t _class=0, _create=0, _ctrl=0, _cwd=0, _data=0, _dpmem=0, _dsmem=0, _dvmem=0, _eval=0;
label_t _exec=0, _free=0, _get=0, _getattr=0, _halt=0, _init=0, _itime=0, _kernel=0;
label_t _load_average=0, _ltime=0, _max_quantum=0, _maxsize=0, _mem_alloc=0, _mem_free=0;
label_t _mem_list=0, _mem_status=0, _mkdir=0, _msleep=0, _name=0, _new=0, _next=0;
label_t _nuke_fs=0, _param=0, _parent=0, _quantum=0, _read=0, _readat=0, _reboot=0;
label_t _remove=0, _rnoblock=0, _root=0, _rtime=0, _self=0, _set=0, _signal=0, _size=0;
label_t _spmem=0, _ssmem=0, _stderr=0, _stdin=0, _stdout=0, _stime=0, _suspend=0, _svmem=0;
label_t _sys_stat=0, _task=0, _thread=0, _tpmem=0, _tsmem=0, _tvmem=0, _vm_alloc=0;
label_t _vm_list=0, _vm_map=0, _vm_reserve=0, _vm_status=0, _w_event=0, _w_param=0;
label_t _wait=0, _wnoblock=0, _write=0, _zone_status=0;


struct init_label label_init[] = {
{"class", (label_t)&_class},
{"create", (label_t)&_create},
{"ctrl", (label_t)&_ctrl},
{"cwd", (label_t)&_cwd},
{"data", (label_t)&_data},
{"dpmem", (label_t)&_dpmem},
{"dsmem", (label_t)&_dsmem},
{"dvmem", (label_t)&_dvmem},
{"eval", (label_t)&_eval},
{"exec", (label_t)&_exec},
{"free", (label_t)&_free},
{"get", (label_t)&_get},
{"getattr", (label_t)&_getattr},
{"halt", (label_t)&_halt},
{"init", (label_t)&_init},
{"itime", (label_t)&_itime},
{"kernel", (label_t)&_kernel},
{"load_average", (label_t)&_load_average},
{"ltime", (label_t)&_ltime},
{"max_quantum", (label_t)&_max_quantum},
{"maxsize", (label_t)&_maxsize},
{"mem_alloc", (label_t)&_mem_alloc},
{"mem_free", (label_t)&_mem_free},
{"mem_list", (label_t)&_mem_list},
{"mem_status", (label_t)&_mem_status},
{"mkdir", (label_t)&_mkdir},
{"msleep", (label_t)&_msleep},
{"name", (label_t)&_name},
{"new", (label_t)&_new},
{"next", (label_t)&_next},
{"nuke_fs", (label_t)&_nuke_fs},
{"param", (label_t)&_param},
{"parent", (label_t)&_parent},
{"quantum", (label_t)&_quantum},
{"read", (label_t)&_read},
{"readat", (label_t)&_readat},
{"reboot", (label_t)&_reboot},
{"remove", (label_t)&_remove},
{"rnoblock", (label_t)&_rnoblock},
{"root", (label_t)&_root},
{"rtime", (label_t)&_rtime},
{"self", (label_t)&_self},
{"set", (label_t)&_set},
{"signal", (label_t)&_signal},
{"size", (label_t)&_size},
{"spmem", (label_t)&_spmem},
{"ssmem", (label_t)&_ssmem},
{"stderr", (label_t)&_stderr},
{"stdin", (label_t)&_stdin},
{"stdout", (label_t)&_stdout},
{"stime", (label_t)&_stime},
{"suspend", (label_t)&_suspend},
{"svmem", (label_t)&_svmem},
{"sys_stat", (label_t)&_sys_stat},
{"task", (label_t)&_task},
{"thread", (label_t)&_thread},
{"tpmem", (label_t)&_tpmem},
{"tsmem", (label_t)&_tsmem},
{"tvmem", (label_t)&_tvmem},
{"vm_alloc", (label_t)&_vm_alloc},
{"vm_list", (label_t)&_vm_list},
{"vm_map", (label_t)&_vm_map},
{"vm_reserve", (label_t)&_vm_reserve},
{"vm_status", (label_t)&_vm_status},
{"w_event", (label_t)&_w_event},
{"w_param", (label_t)&_w_param},
{"wait", (label_t)&_wait},
{"wnoblock", (label_t)&_wnoblock},
{"write", (label_t)&_write},
{"zone_status", (label_t)&_zone_status},
};

int label_init_size = arraysize(label_init);
