/*  vworms.c                                                    (CRC:1d80ec34)
 *      relative path: ./usr
 *      creation date: 1992
 *      last modified: Wed May 22 21:40:05 1996
 *      header update: Wed Dec 18 07:18:36 1996
 *  
 *       User-level programs
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* worms.c
 *   simple worms program for VT100's
 */

#include <sys/types.h>
#include <object.h>
#include <error.h>
#include <stdlib.h>
#include <string.h>

extern label_t _wid, _hgt;


int sx[8] = {0,1,1,1,0,-1,-1,-1};
int sy[8] = {-1,-1,0,1,1,1,0,-1};
char wormchar[8] = {'O','*','#','$','%','0','@','~'};

ushort *vidbase;
int vid_wid,vid_hgt;


static void putworm(int x, int y, int c)
{
	c %= 8;
	vidbase[y*vid_wid+x] = wormchar[c] | (c << 8);
}

static void clearworm(int x, int y)
{
	vidbase[y*132+x] = 0;
}



static void worms(int wid, int hgt, int n, int len)
{
int wx[8][50];
int wy[8][50];
int dir[4];
int i;
int p,last;
	for(i=0; i<n; i++) {
		for(p=0; p<len; p++) {
			wx[i][p] = 0;
			wy[i][p] = 0;	
		}	
		wx[i][0] = rnd(wid);
		wy[i][0] = rnd(hgt);
		dir[i] = rnd(8);
	}
	last = 0;
	p = 1;
	while(1) {
		for(i=0; i<n; i++) {
			clearworm(wx[i][p],wy[i][p]);
			dir[i] = (dir[i] + rnd(2) - rnd(2)) % 8;
			if(wx[i][last] < 1)
				dir[i] = 2;
			if(wx[i][last] > wid-2)
				dir[i] = 6;
			if(wy[i][last] < 1)
				dir[i] = 4;
			if(wy[i][last] > hgt-2)
				dir[i] = 0;
			wx[i][p] = wx[i][last] + sx[dir[i]];
			wy[i][p] = wy[i][last] + sy[dir[i]];
			putworm(wx[i][p],wy[i][p],i);
		}	
		last = p;
		p = (p+1) % len;
	}
}



obj_t Main(ObjFrame *frame, vaddr base, obj_t arg, obj_t env)
{
	vidbase = (ushort*)_(OBJ_TASK, _vm_map, 0xb8000, 16384, ___);
	memset(vidbase, 0, 16384);
	vid_wid = _(OBJ_STDOUT, _get, _wid, ___, ___);
	vid_hgt = _(OBJ_STDOUT, _get, _hgt, ___, ___);
	worms(vid_wid,vid_hgt,8,15);	
	return(OK);
}

