/*  fsattach.c                                                  (CRC:e6e9f6c6)
 *      relative path: ./util
 *      creation date: 1992
 *      last modified: Wed May 22 21:40:21 1996
 *      header update: Wed Dec 18 07:18:40 1996
 *  
 *       Utilities
 *  
 *  Copyright (c) 1992 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution, and is
 *  free software for non-profit uses; it may be freely used and distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'license1.txt'.  If this license is missing,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For sending bug reports, please read the file 'bugs', and always
 *      include the product name and version, and the word 'BUG' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/* fsattach.c
 *   attaches a static file system to an executable
 *   
 *   yes, this is a really quick and cheesy hack,
 *   but it works, and it's only a utility, not part of the kernel,
 *   so I don't care
 */


#define _SIZE_T
#include "/usr/include/stdio.h"
#undef FALSE
#undef TRUE
#undef NULL
#include <sys/types.h>
#include <sys/resource.h>
#include "/usr/include/a.out.h"


/* call with:  <executable> <fsfile> <bss_base(in hex)>
 *	assumes that <executable> has been stripped already 
 */

 
main(argc,argv)
int argc;
char **argv;
{
FILE *f1, *f2;
int n, x, i;
char *buf, *bp;
StaticFS fsnode[256];
ulong size;
ulong nentries;
struct exec *header;
char tmp[1024];
ulong bss_base;
int fssize;
	bss_base = strtoul(argv[3], 0, 16);
	buf = (char*)malloc(1*1024*1024);
	f1 = fopen(argv[1], "r");
	fread(tmp, 1, 1024, f1);
	header = (struct exec*)tmp;
	fread(buf, 1, 65536, f1);
	fclose(f1);
	bp = buf;
	printf("bss_base=%X\n", bss_base);
	bp += (bss_base - KERNBASE);
	printf("bp=%x\n", bp);
	f1 = fopen(argv[2], "r");
	fssize = fread(bp,1,1*1024*1024,f1);
	fclose(f1);
	printf("fssize=%x\n", fssize);
	header->a_data += fssize;
	f1 = fopen(argv[1], "w");
	fwrite(tmp, 1, 1024, f1);
	fwrite(buf, 1, header->a_text+header->a_data, f1);
	fclose(f1);
	exit(0);
}

